import QtQuick 2.0
import Trogl 1.0

Item {
    id: ctrl
    width: ui.c*2+ui.i
    height: ui.c*3+ui.i*2
    property string subjColor: "subgineryLightingColor"
    property string icon: "image://trogl/LightSideScenes/On.svg"
    property alias pressed: ma.pressed
    property color linesColor: Skin.dividerColor
    state: "middle"
    states: [
        State {
            name: "on"
            PropertyChanges { target: _icon; y: ui.c/3 }
        },
        State {
            name: "off"
            PropertyChanges { target: _icon; y: ctrl.height - _icon.height - ui.c/3 }
        },
        State {
            name: "middle"
            PropertyChanges { target: _icon; y: (ctrl.height - _icon.height)/2 }
        }

        ]

    Rectangle {
        id: ltr
        width: ui.c/20
        height: ui.c/6
        anchors.left: parent.left
        anchors.leftMargin: ui.c/6
        anchors.top: parent.top
        anchors.topMargin:  ui.c/6
        color: linesColor
    }
    Rectangle {
        id: rtr
        width: ui.c/20
        height: ui.c/6
        anchors.right: parent.right
        anchors.rightMargin: ui.c/6
        anchors.top: parent.top
        anchors.topMargin:  ui.c/6
        color: linesColor
    }
    Rectangle {
        height: ui.c/20
        anchors.left: ltr.right
        anchors.right: rtr.left
        anchors.top: ltr.top
        color: linesColor
    }


    Rectangle {
        id: lbr
        width: ui.c/20
        height: ui.c/6
        anchors.left: parent.left
        anchors.leftMargin: ui.c/6
        anchors.bottom: parent.bottom
        anchors.bottomMargin:  ui.c/6
        color: linesColor
    }
    Rectangle {
        id: rbr
        width: ui.c/20
        height: ui.c/6
        anchors.right: parent.right
        anchors.rightMargin: ui.c/6
        anchors.bottom: parent.bottom
        anchors.bottomMargin:  ui.c/6
        color: linesColor
    }
    Rectangle {
        height: ui.c/20
        anchors.left: lbr.right
        anchors.right: rbr.left
        anchors.bottom: lbr.bottom
        color: linesColor
    }

    TroglImage {
        width: ui.c/2
        height: ui.c/2
        anchors.top: parent.top
        anchors.topMargin: ui.c/6
        anchors.horizontalCenter: parent.horizontalCenter
        source: "image://trogl/LeverCtrl/ArrowUp.svg?iconSystem2="+subjColor
        visible: ma.pressed
    }

    TroglImage {
        width: ui.c/2
        height: ui.c/2
        anchors.bottom: parent.bottom
        anchors.bottomMargin: ui.c/6
        anchors.horizontalCenter: parent.horizontalCenter
        source: "image://trogl/LeverCtrl/ArrowDown.svg?iconSystem2="+subjColor
        visible: ma.pressed
    }
    TroglImage {
        id: _icon
        width: ui.c*1.7+ui.i
        height: ui.c*1.7+ui.i
        source: ctrl.icon
        anchors.horizontalCenter: parent.horizontalCenter
        Behavior on y {
            NumberAnimation { duration: 300 }
        }
    }
    MouseArea {
        id: ma
        anchors.fill: parent
        property real px
        property real py
        onPressed: {
            px = mouseX
            py = mouseX
        }

        onMouseYChanged: {
            if((mouseX >0) && (mouseX < width) &&
               (Math.abs(px - mouseX) < Math.abs(py - mouseY)))
            {
                if((ctrl.state != "on") && (mouseY < py - ui.c))
                {
                    ctrl.state = "on"
                    py = mouseY
                }
                else
                if((ctrl.state != "off") && (mouseY > py + ui.c))
                {
                    ctrl.state = "off"
                    py = mouseY
                }
            }
        }
    }
}
