import QtQuick 2.0
import Trogl 1.0

Item {
    id: ctrl
    width:  ui.c*2+ui.i
    height: ui.c*2+ui.i
    clip: !ma.pressed
    property int value: 0
    signal pressed()
    property string onUrl
    property string offUrl
    property string undefUrl

    Column {
        id: col
        width: parent.width
        height: ui.c*6+ui.i*3
        y : -value*(2*ui.c+ui.i)

        Behavior on y { PropertyAnimation {duration: 300} }
        ClBtn{
            img.source: onUrl
        }
        ClBtn{
            img.source: undefUrl
        }
        ClBtn{
            img.source: offUrl
        }
    }
    MouseArea {
        id: ma
        anchors.fill: parent
        property real py: 0
        onPressed: {
            py = mouseY
            ctrl.pressed()
        }
        onMouseYChanged: {
            if(Math.abs(py-mouseY) > (ui.c*2+ui.i))
            {
                calcIndex()
                py = mouseY
            }
        }
    }

    function calcIndex()
    {
        if(ma.py > ma.mouseY)
            value = Math.min(value+1, 2)
        else
            value = Math.max(value-1, 0)
    }
}
